import requests
import random
import string

class SecMail:
    BASE_URL = "https://2secmail.cloud/api"
    API_KEY = "pYZz8IPL1S7BJDv6GMlA"

    @staticmethod
    def _request(endpoint):
        url = f"{SecMail.BASE_URL}/{endpoint}/{SecMail.API_KEY}"
        response = requests.get(url)
        
        print("Statut HTTP:", response.status_code)  # Debug
        print("Réponse brute:", repr(response.text))  # Debug

        return response.text  # Retourne toujours du texte brut

    @staticmethod
    def get_domains():
        return SecMail._request("domains").split(',')

    @staticmethod
    def create_random_email():
        domains = SecMail.get_domains()
        if not domains or isinstance(domains, str):
            raise ValueError("Impossible de récupérer les domaines.")

        random_name = ''.join(random.choices(string.ascii_lowercase + string.digits, k=10))
        email = f"{random_name}@{domains[0]}"
        return SecMail._request(f"email/{email}")

    @staticmethod
    def create_custom_email(name):
        domains = SecMail.get_domains()
        if not domains or isinstance(domains, str):
            raise ValueError("Impossible de récupérer les domaines.")
        
        email = f"{name}@{domains[0]}"
        return SecMail._request(f"email/{email}")

    @staticmethod
    def get_messages(email):
        return SecMail._request(f"messages/{email}")

    @staticmethod
    def get_message(message_id):
        return SecMail._request(f"message/{message_id}")

    @staticmethod
    def delete_message(message_id):
        url = f"{SecMail.BASE_URL}/message/{message_id}/{SecMail.API_KEY}"
        response = requests.delete(url)
        return response.status_code == 200
